/*
** Header file for the BeOS implementation of the TinyPTC lib
** Code by Johnny BARRAY (jbarray@worldonline.fr)
** Please check http://jbarray.free.fr
*/
#include <Application.h>
#include <DirectWindow.h>
#include <Locker.h>

#include "tinyptc.h"
#include "convert.h"

#define SNOOZE_TIME 1000

/*
** Main Window class definition
**
*/
class TinyPTCWindow : public BDirectWindow
{
  public:
    TinyPTCWindow(const char *title,int width,int height);
    ~TinyPTCWindow();
  	void Update(void *buffer);
	virtual void MessageReceived(BMessage* msg);
	virtual bool QuitRequested();
	virtual void DirectConnected(direct_buffer_info *info);

  private:
  	bool bDestroying;
  	bool bWindowModeAvailable;
  	bool bConnected;
  	bool bInFullScreenMode;
  	bool bNeedErase;
	thread_id DrawingThread;
	BLocker* pLocker;
	BLocker* pLockerFullScreen;

	int demoScreenWidth;
	int demoScreenHeight;
	bool bNeedUpdate;
	uint32* pScreenToShow;

	uint8* fBits;
	int32 fRowBytes;
	int32 fPixelBytes;
	color_space fFormat;
	clipping_rect fBounds;
	uint32 fNumClipRects;
	clipping_rect* fClipList;
	PTC_CONVERTER ptc_current_converter;

	static int32 DrawDirectWindow(void *ptr);
};

/*
** Application class definition
**
*/
class TinyPTCBeOS : public BApplication
{ 
  public:
  	TinyPTCBeOS(const char *title,int width,int height);
    ~TinyPTCBeOS();
  	void Update(void *buffer);

  private:
  	TinyPTCWindow* pDemoScreen;
};
